from bolsonaro.models.omp_forest_classifier import OmpForestClassifier
from bolsonaro.models.omp_forest_regressor import OmpForestRegressor
from bolsonaro.data.task import Task


class ModelFactory(object):

    @staticmethod
    def build(task, forest_size, extracted_forest_size, seed=None):
        if task == Task.CLASSIFICATION:
            model_func = OmpForestClassifier
        elif task == Task.REGRESSION:
            model_func = OmpForestRegressor
        else:
            raise ValueError("Unsupported task '{}'".format(task))
        return model_func(
            forest_size=forest_size,
            extracted_forest_size=extracted_forest_size,
            seed=seed
        )
